package fr.plnech.dunbar.model

import android.graphics.Bitmap
import android.provider.ContactsContract.Contacts
import java.util.*

data class Friend(val map: MutableMap<String, String?>, val photo: Bitmap?) {
    override fun toString(): String = "$name"

    fun mapString(): String = map.entries.filter { !it.value.isNullOrEmpty() }.toString()

    val name: String?
        get() = map[Contacts.DISPLAY_NAME]

    val id: Int
        get() = map[Contacts._ID]!!.toInt()

    val phone: String?
        get() = map["data1"]

    val lastTimeStamp = map[Contacts.LAST_TIME_CONTACTED]!!.toLong()

    val lastDate: Date?
        get() = if (lastTimeStamp > 0) Date(lastTimeStamp) else null

    val timesContacted: Int
        get() = map[Contacts.TIMES_CONTACTED]?.toInt() ?: 0

    val isYou: String?
        get() = map[Contacts.IS_USER_PROFILE]

    val visibleOutsideSearch: String?
        get() = map[Contacts.IN_DEFAULT_DIRECTORY]
}